Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 4228)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 4229)
@@ -463,17 +463,35 @@
    !!                   INTERFACE iom_get
    !!----------------------------------------------------------------------
-   SUBROUTINE iom_g0d( kiomid, cdvar, pvar )
+   SUBROUTINE iom_g0d( kiomid, cdvar, pvar, ktime )
       INTEGER         , INTENT(in   )                 ::   kiomid    ! Identifier of the file
       CHARACTER(len=*), INTENT(in   )                 ::   cdvar     ! Name of the variable
       REAL(wp)        , INTENT(  out)                 ::   pvar      ! read field
-      !
-      INTEGER               :: idvar   ! variable id
+      INTEGER         , INTENT(in   ),     OPTIONAL   ::   ktime     ! record number
+      !
+      INTEGER                                         ::   idvar     ! variable id
+      INTEGER                                         ::   idmspc    ! number of spatial dimensions
+      INTEGER         , DIMENSION(1)                  ::   itime     ! record number
+      CHARACTER(LEN=100)                              ::   clinfo    ! info character
+      CHARACTER(LEN=100)                              ::   clname    ! file name
+      CHARACTER(LEN=1)                                ::   cldmspc   !
+      !
+      itime = 1
+      IF( PRESENT(ktime) ) itime = ktime
+      !
+      clname = iom_file(kiomid)%name
+      clinfo = '          iom_g0d, file: '//trim(clname)//', var: '//trim(cdvar)
       !
       IF( kiomid > 0 ) THEN
          idvar = iom_varid( kiomid, cdvar )
          IF( iom_file(kiomid)%nfid > 0 .AND. idvar > 0 ) THEN
+            idmspc = iom_file ( kiomid )%ndims( idvar )
+            IF( iom_file(kiomid)%luld(idvar) )  idmspc = idmspc - 1
+            WRITE(cldmspc , fmt='(i1)') idmspc
+            IF( idmspc > 0 )  CALL ctl_stop( TRIM(clinfo), 'When reading to a 0D array, we do not accept data', &
+                                 &                         'with 1 or more spatial dimensions: '//cldmspc//' were found.' , &
+                                 &                         'Use ncwa -a to suppress the unnecessary dimensions' )
             SELECT CASE (iom_file(kiomid)%iolib)
-            CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, pvar )
-            CASE (jpnf90   )   ;   CALL iom_nf90_get(    kiomid, idvar, pvar )
+            CASE (jpioipsl )   ;   CALL iom_ioipsl_get(  kiomid, idvar, pvar, itime )
+            CASE (jpnf90   )   ;   CALL iom_nf90_get(    kiomid, idvar, pvar, itime )
             CASE (jprstdimg)   ;   CALL iom_rstdimg_get( kiomid, idvar, pvar )
             CASE DEFAULT    
@@ -640,5 +658,5 @@
                ELSE
                   CALL ctl_stop( TRIM(clinfo), 'To keep iom lisibility, when reading a '//clrankpv//'D array,'         ,   &
-                     &                         'we do not accept data with more than '//cldmspc//' spatial dimension',   &
+                     &                         'we do not accept data with '//cldmspc//' spatial dimensions',   &
                      &                         'Use ncwa -a to suppress the unnecessary dimensions' )
                ENDIF
@@ -752,5 +770,5 @@
 
          IF( istop == nstop ) THEN   ! no additional errors until this point...
-            IF(lwp) WRITE(numout,"(10x,' read ',a,' (rec: ',i4,') in ',a,' ok')") TRIM(cdvar), itime, TRIM(iom_file(kiomid)%name)
+            IF(lwp) WRITE(numout,"(10x,' read ',a,' (rec: ',i6,') in ',a,' ok')") TRIM(cdvar), itime, TRIM(iom_file(kiomid)%name)
           
             !--- overlap areas and extra hallows (mpp)
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 4228)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 4229)
@@ -170,4 +170,5 @@
             iom_file(kiomid)%cn_var(kiv) = TRIM(cdvar)
             iom_file(kiomid)%ndims(kiv)  = i_nvd
+            iom_file(kiomid)%dimsz(:,kiv) = 0   ! reset dimsz in case previously used
             CALL flioinqv( ioipslid, cdvar, ll_fnd,   &
                   &           len_dims = iom_file(kiomid)%dimsz(1:i_nvd,kiv), &   ! dimensions size
@@ -210,5 +211,5 @@
 
 
-   SUBROUTINE iom_ioipsl_g0d( kiomid, kvid, pvar )
+   SUBROUTINE iom_ioipsl_g0d( kiomid, kvid, pvar, kstart )
       !!-----------------------------------------------------------------------
       !!                  ***  ROUTINE  iom_ioipsl_g0d  ***
@@ -216,9 +217,10 @@
       !! ** Purpose : read a scalar with IOIPSL (only fliocom module)
       !!-----------------------------------------------------------------------
-      INTEGER , INTENT(in   ) ::   kiomid    ! Identifier of the file
-      INTEGER , INTENT(in   ) ::   kvid      ! variable id
-      REAL(wp), INTENT(  out) ::   pvar      ! read field
-      !
-      CALL fliogetv( iom_file(kiomid)%nfid, TRIM(iom_file(kiomid)%cn_var(kvid)), pvar )
+      INTEGER ,               INTENT(in   )            ::   kiomid    ! Identifier of the file
+      INTEGER ,               INTENT(in   )            ::   kvid      ! variable id
+      REAL(wp),               INTENT(  out)            ::   pvar      ! read field
+      INTEGER , DIMENSION(1), INTENT(in   ), OPTIONAL  ::   kstart    ! start position of the reading in each axis
+      !
+      CALL fliogetv( iom_file(kiomid)%nfid, TRIM(iom_file(kiomid)%cn_var(kvid)), pvar, kstart )
       ! 
    END SUBROUTINE iom_ioipsl_g0d
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 4228)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 4229)
@@ -216,4 +216,5 @@
          CALL iom_nf90_check(NF90_Inquire_Variable(if90id, ivarid, dimids = idimid(1:i_nvd)), clinfo)   ! dimensions ids
          iom_file(kiomid)%luld(kiv) = .FALSE.   ! default value
+         iom_file(kiomid)%dimsz(:,kiv) = 0   ! reset dimsz in case previously used
          DO ji = 1, i_nvd                       ! dimensions size
             CALL iom_nf90_check(NF90_Inquire_Dimension(if90id, idimid(ji), len = iom_file(kiomid)%dimsz(ji,kiv)), clinfo)   
@@ -249,5 +250,5 @@
 
 
-   SUBROUTINE iom_nf90_g0d( kiomid, kvid, pvar )
+   SUBROUTINE iom_nf90_g0d( kiomid, kvid, pvar, kstart )
       !!-----------------------------------------------------------------------
       !!                  ***  ROUTINE  iom_nf90_g0d  ***
@@ -255,12 +256,13 @@
       !! ** Purpose : read a scalar with NF90
       !!-----------------------------------------------------------------------
-      INTEGER , INTENT(in   ) ::   kiomid   ! Identifier of the file
-      INTEGER , INTENT(in   ) ::   kvid     ! variable id
-      REAL(wp), INTENT(  out) ::   pvar     ! read field
+      INTEGER ,               INTENT(in   )            ::   kiomid   ! Identifier of the file
+      INTEGER ,               INTENT(in   )            ::   kvid     ! variable id
+      REAL(wp),               INTENT(  out)            ::   pvar     ! read field
+      INTEGER , DIMENSION(1), INTENT(in   ), OPTIONAL  ::   kstart   ! start position of the reading in each axis
       !
       CHARACTER(LEN=100)      ::   clinfo   ! info character
       !---------------------------------------------------------------------
       clinfo = 'iom_nf90_g0d , file: '//TRIM(iom_file(kiomid)%name)//', var: '//TRIM(iom_file(kiomid)%cn_var(kvid))
-      CALL iom_nf90_check(NF90_GET_VAR(iom_file(kiomid)%nfid, iom_file(kiomid)%nvid(kvid), pvar), clinfo )
+      CALL iom_nf90_check(NF90_GET_VAR(iom_file(kiomid)%nfid, iom_file(kiomid)%nvid(kvid), pvar, start = kstart), clinfo )
       ! 
    END SUBROUTINE iom_nf90_g0d
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 4228)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 4229)
@@ -21,4 +21,5 @@
    USE par_oce
    USE dom_oce                  ! Ocean space and time domain variables
+   USE obs_fbm, ONLY: ln_cl4    ! Class 4 diagnostic switch
    USE obs_read_prof            ! Reading and allocation of observations (Coriolis)
    USE obs_read_sla             ! Reading and allocation of SLA observations  
@@ -48,5 +49,6 @@
    PUBLIC dia_obs_init, &  ! Initialize and read observations
       &   dia_obs,      &  ! Compute model equivalent to observations
-      &   dia_obs_wri      ! Write model equivalent to observations
+      &   dia_obs_wri,  &  ! Write model equivalent to observations
+      &   dia_obs_dealloc  ! Deallocate dia_obs data
 
    !! * Shared Module variables
@@ -80,4 +82,5 @@
    LOGICAL, PUBLIC :: ln_ssh         !: Logical switch for sea surface height
    LOGICAL, PUBLIC :: ln_sss         !: Logical switch for sea surface salinity
+   LOGICAL, PUBLIC :: ln_sstnight    !: Logical switch for night mean SST observations
    LOGICAL, PUBLIC :: ln_nea         !: Remove observations near land
    LOGICAL, PUBLIC :: ln_altbias     !: Logical switch for altimeter bias  
@@ -167,4 +170,5 @@
          &            nmsshc, mdtcorr, mdtcutoff,                     &
          &            ln_reysst, ln_ghrsst, reysstname, reysstfmt,    &
+         &            ln_sstnight,                                    &
          &            ln_grid_search_lookup,                          &
          &            grid_search_file, grid_search_res,              &
@@ -176,5 +180,5 @@
          &            ln_velhradcp, velhradcpfiles,                   &
          &            ln_velfb, velfbfiles, ln_velfb_av,              &
-         &            ln_profb_enatim, ln_ignmis
+         &            ln_profb_enatim, ln_ignmis, ln_cl4
 
       INTEGER :: jprofset
@@ -226,8 +230,10 @@
       ln_velhradcp = .FALSE.
       ln_velfb = .FALSE.
+      ln_sstnight = .FALSE.
       ln_nea = .FALSE.
       ln_grid_search_lookup = .FALSE.
       ln_grid_global = .FALSE.
       ln_s_at_t = .TRUE.
+      ln_cl4 = .FALSE.
       grid_search_file = 'xypos'
       bias_file='bias.nc'
@@ -357,4 +363,5 @@
          WRITE(numout,*) '             Logical switch for GHRSST observations          ln_ghrsst = ', ln_ghrsst
          WRITE(numout,*) '             Logical switch for feedback SST data             ln_sstfb = ', ln_sstfb
+         WRITE(numout,*) '             Logical switch for night-time SST obs         ln_sstnight = ', ln_sstnight
          WRITE(numout,*) '             Logical switch for SSS observations                ln_sss = ', ln_sss
          WRITE(numout,*) '             Logical switch for Sea Ice observations         ln_seaice = ', ln_seaice
@@ -750,5 +757,5 @@
             nsstsets = nsstsets + 1
 
-            ld_sstnight(nsstsets) = .TRUE.
+            ld_sstnight(nsstsets) = ln_sstnight
 
             CALL obs_rea_sst_rey( reysstname, reysstfmt, sstdata(nsstsets), &
@@ -764,5 +771,5 @@
             nsstsets = nsstsets + 1
 
-            ld_sstnight(nsstsets) = .TRUE.
+            ld_sstnight(nsstsets) = ln_sstnight
           
             CALL obs_rea_sst( 1, sstdata(nsstsets), jnumsst, &
@@ -783,5 +790,5 @@
                nsstsets = nsstsets + 1
 
-               ld_sstnight(nsstsets) = .TRUE.
+               ld_sstnight(nsstsets) = ln_sstnight
             
                CALL obs_rea_sst( 0, sstdata(nsstsets), 1, &
@@ -1414,4 +1421,45 @@
    END SUBROUTINE dia_obs_wri
 
+   SUBROUTINE dia_obs_dealloc
+      IMPLICIT NONE
+      !!----------------------------------------------------------------------
+      !!                    *** ROUTINE dia_obs_dealloc ***
+      !!
+      !!  ** Purpose : To deallocate data to enable the obs_oper online loop.
+      !!               Specifically: dia_obs_init --> dia_obs --> dia_obs_wri
+      !!
+      !!  ** Method : Clean up various arrays left behind by the obs_oper.
+      !!
+      !!  ** Action :
+      !!
+      !!----------------------------------------------------------------------
+      !! obs_grid deallocation
+      CALL obs_grid_deallocate
+
+      !! diaobs deallocation
+      IF ( nprofsets > 0 ) THEN
+          DEALLOCATE(ld_enact, &
+                  &  profdata, &
+                  &  prodatqc)
+      END IF
+      IF ( ln_sla ) THEN
+          DEALLOCATE(sladata, &
+                  &  sladatqc)
+      END IF
+      IF ( ln_seaice ) THEN
+          DEALLOCATE(sladata, &
+                  &  sladatqc)
+      END IF
+      IF ( ln_sst ) THEN
+          DEALLOCATE(sstdata, &
+                  &  sstdatqc)
+      END IF
+      IF ( ln_vel3d ) THEN
+          DEALLOCATE(ld_velav, &
+                  &  velodata, &
+                  &  veldatqc)
+      END IF
+   END SUBROUTINE dia_obs_dealloc
+
    SUBROUTINE ini_date( ddobsini )
       !!----------------------------------------------------------------------
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/mpp_map.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/mpp_map.F90	(revision 4228)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/mpp_map.F90	(revision 4229)
@@ -52,8 +52,9 @@
       !!----------------------------------------------------------------------
 
-      ALLOCATE( &
-         & mppmap(jpiglo,jpjglo) &
-         & )
-
+      IF (.NOT. ALLOCATED(mppmap)) THEN
+         ALLOCATE( &
+            & mppmap(jpiglo,jpjglo) &
+            & )
+      ENDIF
       ! Initialize local imppmap
 
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fbm.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fbm.F90	(revision 4228)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fbm.F90	(revision 4229)
@@ -45,5 +45,9 @@
    INTEGER, PARAMETER    :: fbimdi = -99999   !: Integers
    REAL(fbsp), PARAMETER :: fbrmdi =  99999   !: Reals
-   
+
+   ! Output stream choice
+   LOGICAL               :: ln_cl4 = .FALSE.  !: Logical switch for
+                                              !: class 4 file outputs
+ 
    ! Main data structure for observation feedback data.
 
@@ -1026,4 +1030,31 @@
 
    SUBROUTINE write_obfbdata( cdfilename, fbdata )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE write_obfbdata  ***
+      !!
+      !! ** Purpose :   Write an obfbdata structure into a netCDF file.
+      !!
+      !! ** Method  :   Decides which output wrapper to use. 
+      !!
+      !! ** Action  : 
+      !!
+      !!----------------------------------------------------------------------
+      !! * Arguments
+      CHARACTER(len=*) :: cdfilename ! Output filename
+      TYPE(obfbdata)   :: fbdata     ! obsfbdata structure
+#if defined key_offobsoper
+      IF (ln_cl4) THEN
+          ! Class 4 file output stream
+          CALL write_obfbdata_cl( cdfilename, fbdata )
+      ELSE
+#endif
+          ! Standard feedback file output stream
+          CALL write_obfbdata_fb( cdfilename, fbdata )
+#if defined key_offobsoper
+      ENDIF
+#endif
+   END SUBROUTINE write_obfbdata
+
+   SUBROUTINE write_obfbdata_fb( cdfilename, fbdata )
       !!----------------------------------------------------------------------
       !!                    ***  ROUTINE write_obfbdata  ***
@@ -1524,5 +1555,237 @@
 
       
-   END SUBROUTINE write_obfbdata
+   END SUBROUTINE write_obfbdata_fb
+
+#if defined key_offobsoper
+   SUBROUTINE write_obfbdata_cl(cdfilename, fbdata)
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE write_obfbdata_cl  ***
+      !!
+      !! ** Purpose : Write an obfbdata structure into a class 4 file.
+      !!
+      !! ** Method  : 1. Allocate memory needed by ooo_write
+      !!              2. Map obfbdata into allocated memory
+      !!              3. Pass mapped data to ooo_write
+      !!              4. Deallocate memory
+      !!----------------------------------------------------------------------
+      USE dom_oce, ONLY: narea
+      USE ooo_write
+      USE ooo_data
+      !! * Arguments
+      CHARACTER(len=*) :: cdfilename ! Feedback filename
+      TYPE(obfbdata)   :: fbdata     ! obsfbdata structure
+      !! * Local variables
+      CHARACTER(len=17), PARAMETER :: cpname = 'write_obfbdata_cl'
+      CHARACTER(len=64) :: &
+              & cdate, &   !: class 4 file validity date 
+              & cconf, &   !: model configuration
+              & csys, &    !: model system
+              & ccont, &   !: contact email
+              & cinst, &   !: institution
+              & cversion   !: model version
+      CHARACTER(len=8) :: &
+              & ckind      !: observation kind
+      CHARACTER(len=3) :: cfield
+      INTEGER :: kobs, &   !: number of observations
+              &  kvars, &  !: number of physical variables
+              &  kdeps, &  !: number of observed depths
+              &  kfcst, &  !: number of forecasts
+              &  kifcst, & !: current forecast number
+              &  kproc     !: processor number
+      INTEGER, DIMENSION(:, :, :), ALLOCATABLE :: &
+              &  kqc       !: quality control counterpart
+      INTEGER(KIND=2), DIMENSION(:, :, :), ALLOCATABLE :: &
+              &  k2qc       !: quality control counterpart
+      REAL(kind=fbdp) :: &
+              &  pmodjuld  !: model Julian day
+      REAL(kind=fbdp), DIMENSION(:), ALLOCATABLE :: &
+              &  plead, &  !: forecast lead time
+              &  plam, &   !: longitude of observation
+              &  pphi, &   !: latitude of observation
+              &  ptim      !: time of observation
+      REAL(kind=fbdp), DIMENSION(:, :), ALLOCATABLE :: &
+              &  pdep      !: depths of observations
+      REAL(kind=fbdp), DIMENSION(:, :, :), ALLOCATABLE :: &
+              &  pob, &    !: observation counterpart
+              &  pextra    !: extra field counterpart
+      REAL(kind=fbdp), DIMENSION(:, :, :), ALLOCATABLE :: &
+              &  pmod      !: model counterpart
+      CHARACTER(len=128) :: &
+              &  clfilename  !: class 4 file name
+      CHARACTER(len=128), DIMENSION(:), ALLOCATABLE :: &
+              &  ctype       !: Instrument type
+      CHARACTER(len=nf90_max_name) :: &
+              & cdtmp        !: NetCDF variable name
+      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: &
+              &  cwmo, &     !: Instrument WMO ID
+              &  cunit, &    !: Instrument WMO ID
+              &  cvarname    !: Instrument WMO ID
+      INTEGER :: &
+              &  idep, &     !: Loop variable
+              &  ivar, &     !: Loop variable
+              &  iobs, &     !: Loop variable
+              &  ii, &       !: Loop variable
+              &  ij, &       !: Loop variable
+              &  ik, &       !: Loop variable
+              &  il          !: Loop variable
+      cconf = TRIM(cl4_cfg)
+      csys = TRIM(cl4_sys)
+      cversion = TRIM(cl4_vn)
+      ccont = TRIM(cl4_contact)
+      cinst = TRIM(cl4_inst)
+      cdate = TRIM(cl4_date)
+      CALL locate_kind(cdfilename, ckind)
+      kproc = narea
+      kfcst = cl4_fcst_len
+      kobs = fbdata%nobs
+      kdeps = fbdata%nlev
+      kvars = fbdata%nvar
+      IF (kobs .GT. 0) THEN
+         ALLOCATE(plam(kobs), &
+               &  pphi(kobs), &
+               &  ptim(kobs), &
+               &  plead(kfcst), &
+               &  pdep(kdeps, kobs), &
+               &  kqc(kdeps, kvars, kobs), &
+               &  k2qc(kdeps, kvars, kobs), &
+               &  pob(kdeps, kvars, kobs), &
+               &  pmod(kdeps, kvars, kobs), &
+               &  pextra(kdeps, kvars, kobs), &
+               &  ctype(kobs), &
+               &  cwmo(kobs), &
+               &  cunit(kvars), &
+               &  cvarname(kvars))
+         plam(:) = fbdata%plam(:)
+         pphi(:) = fbdata%pphi(:)
+         ptim(:) = fbdata%ptim(:)
+         pdep(:, :) = fbdata%pdep(:, :)
+         kqc(:,:,:) = 1.
+         DO ii = 1, kvars
+            cvarname(ii)  = fbdata%cname(ii)
+            cunit(ii)     = fbdata%cobunit(ii)
+         END DO
+
+         ! Quality control algorithm
+         k2qc(:,:,:) = NF90_FILL_SHORT
+         DO idep = 1,kdeps
+            DO ivar = 1, kvars
+               DO iobs = 1, kobs
+                  ! 1 symbolises good for fbdata
+                  ! fbimdi symbolises that qc has not been set
+                  ! Essentially, if any fbdata flag is not an element of {1, fbimdi}
+                  ! then set the class 4 flag to bad.
+                  ! Note: fbdata%ioqc is marked good if zero.
+                  IF (((fbdata%ioqc(iobs) /= 0) .AND. &
+                            & (fbdata%ioqc(iobs) /= fbimdi)) .OR. &
+                    & ((fbdata%ipqc(iobs) /= 1) .AND. &
+                            & (fbdata%ipqc(iobs) /= fbimdi)) .OR. &
+                    & ((fbdata%idqc(idep,iobs) /= 1) .AND. &
+                            & (fbdata%idqc(idep,iobs) /= fbimdi)) .OR. &
+                    & ((fbdata%ivqc(iobs,ivar) /= 1) .AND. &
+                            & (fbdata%ivqc(iobs,ivar) /= fbimdi)) .OR. &
+                    & ((fbdata%ivlqc(idep,iobs,ivar) /= 1) .AND. &
+                            & (fbdata%ivlqc(idep,iobs,ivar) /= fbimdi)) .OR. &
+                    & ((fbdata%itqc(iobs) /= 1) .AND. &
+                            & (fbdata%itqc(iobs) /= fbimdi))) THEN
+                     ! 1 symbolises bad for class 4 file
+                     k2qc(idep, ivar, iobs) = 1
+                  ELSE
+                     ! 0 symbolises good for class 4 file
+                     k2qc(idep, ivar, iobs) = 0
+                  END IF 
+               END DO
+            END DO
+         END DO
+
+         ! Permute observation dimensions
+         pob(:,:,:) = RESHAPE(fbdata%pob, (/kdeps, kvars, kobs/), &
+                            & ORDER=(/1, 3, 2/))
+
+         ! Explicit model counterpart dimension permutation
+         ! 1,2,3,4 --> 1,4,2,3
+         pmod(:,:,:) = fbrmdi
+         ij = cl4_fcst_idx(jimatch)
+         DO ii = 1,kdeps
+            DO ik = 1, kvars
+               DO il = 1, kobs
+                  pmod(ii,ik,il) = fbdata%padd(ii,il,1,ik)
+               END DO
+            END DO
+         END DO
+
+         ! Extra fields set to missing for now
+         pextra(:,:,:) = fbrmdi
+
+         ! Lead time of class 4 file is a global parameter
+         plead = cl4_leadtime(1:cl4_fcst_len)
+
+         ! Model Julian day
+         pmodjuld = cl4_modjuld
+
+         ! Observation types
+         ctype(:) = 'X'
+         DO ii = 1,kobs
+            ctype(ii) = fbdata%cdtyp(ii)
+         END DO
+
+         ! World Meteorology Organisation codes
+         cwmo(:) = fbdata%cdwmo(:)
+
+         ! Initialise class 4 file
+         CALL ooo_wri_init(cconf, csys, ckind, cversion, ccont, cinst, cdate, &
+                         & kproc, kobs, kvars, kdeps, kfcst, &
+                         & clfilename)
+
+         ! Write standard variables
+         CALL ooo_wri_default(clfilename, kobs, kvars, kfcst, kdeps, &
+                            & ctype, cwmo, cunit, cvarname, &
+                            & plam, pphi, pdep, ptim, pob, plead, &
+                            & k2qc, pmodjuld)
+         !! Write to optional variables
+         cdtmp = cl4_vars(jimatch)
+         IF ( (TRIM(cdtmp) == "forecast") .OR. &
+              (TRIM(cdtmp) == "persistence") ) THEN
+            !! 4D variables
+            CALL ooo_wri_extra(clfilename, TRIM(cdtmp), kdeps, kfcst, &
+                            &  kvars, kobs, (/ 1,ij,1,1 /), (/ kdeps,1,kvars,kobs /), pmod)
+         ELSE
+            !! 3D variables
+            CALL ooo_wri_extra(clfilename, TRIM(cdtmp), kdeps, &
+                            &  kvars, kobs, (/ 1,1,1 /), (/ kdeps,kvars,kobs /), pmod)
+         ENDIF
+
+         DEALLOCATE(plam, pphi, ptim, pdep, plead, kqc, k2qc, &
+                  & pob, pmod, pextra, ctype, cwmo, &
+                  & cunit, cvarname)
+      END IF
+   END SUBROUTINE write_obfbdata_cl
+#endif
+
+#if defined key_offobsoper
+   SUBROUTINE locate_kind(cdfilename, ckind)
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE locate_kind  ***
+      !!
+      !! ** Purpose : Detect which kind of class 4 file is being produced.
+      !!
+      !! ** Method  : 1. Inspect cdfilename for observation kind.
+      !!----------------------------------------------------------------------
+      CHARACTER(len=*) :: cdfilename ! Feedback filename
+      CHARACTER(len=8) :: ckind
+      IF (cdfilename(1:3) == 'sst') THEN
+         ckind = 'SST'
+      ELSE IF (cdfilename(1:3) == 'sla') THEN
+         ckind = 'SLA'
+      ELSE IF (cdfilename(1:3) == 'pro') THEN
+         ckind = 'profile'
+      ELSE IF (cdfilename(1:3) == 'ena') THEN
+         ckind = 'profile'
+      ELSE IF (cdfilename(1:3) == 'sea') THEN
+         ckind = 'seaice'
+      ELSE
+         ckind = 'unknown'
+      END IF
+   END SUBROUTINE locate_kind
+#endif
 
    SUBROUTINE putvaratt_obfbdata( idfile, idvar, cdlongname, cdunits, &
